// Player.m

#import "Tenant.h"
#import <simtools.h>
#import <random.h>

@implementation Tenant

-init: (int) n {
  homeFloor = n;
  if ([uniformIntRand getIntegerWithMin: 0 withMax: 1])
    floor = homeFloor;
  else
    floor = 0;
  waitingTime = 0;
  trips = 0;
  return self;
}

-setFloor: (int) f {
  floor = f;
  return self;
}

-(BOOL)isAtHome {
  return floor == homeFloor;
}

-(int)getTime {
  return waitingTime;
}

-move: (id) e {
  waitingTime = waitingTime + [e callAtFloor: floor];
  if ([self isAtHome])
    [e take: self toFloor: 0];
  else
    [e take: self toFloor: homeFloor];
  trips++;
  return self;
}

@end


