// ModelSwarm.h					

#import "Player.h"
#import "Tournament.h"
#import <objectbase.h>
#import <objectbase/Swarm.h>
#import <space.h>
#import <space/Discrete2d.h>
#import <random.h>
#import "def.h"


@interface ModelSwarm: Swarm {
  id playerList;
  int time, numGen, randomSeed;
  int numPlayers, num[4];
  int numIter;
  double coopPayoff;
  double pALLC, pTFT, pATFT, pALLD;
  int numNeighbors;
  id <Discrete2d> world;
  int worldSize;
  int sizeFactor;
  id tournament;
}

+createBegin: (id) aZone;
-createEnd;
-buildObjects;
-setNeighborhoods;
-setNeighborhood: (id) player atDX: (int) x DY: (int) y;
-(BOOL) validX: (int) x Y: (int) y;
-(id) getWorld;
-setSizeFactor: (int) s;
-(id) getPlayers;
-resetPlayers;
-setSeed: (long int) s;
-setSize: (int) s;
-(int) getSize;
-setNumIter: (int) n;
-setCoopPayoff: (PAYOFF) p;
-(int) getNum0;
-(int) getNum1;
-(int) getNum2;
-(int) getNum3;
-runTournaments;
-runTournament: player1 against: player2;
-reportResults;
-step;
-shuffle: list;

@end


