// Tournament.m					SimpleBug app

#import "ModelSwarm.h"
#import <simtools.h>

PAYOFF matrix[2][2]={{1,5},{0,3}};

@implementation Tournament

+createBegin: (id)  aZone {
  Tournament * obj;

  obj = [super createBegin: aZone];
  obj->numIter = 4;

  return obj;
}

-createEnd {
  return [super createEnd];

}

-setPlayer1: p1  Player2: p2 {
  player1 = p1;
  player2 = p2;
  [player1 setOtherPlayer: player2];
  [player2 setOtherPlayer: player1];
  return self;
}

-setNumIter: (int) n {
  numIter = n;
  return self;
}

-setCoopPayoff: (PAYOFF) p {
  matrix[1][1] = p;
  return self;
}

-updateMemories {
  [player1 remember];
  [player2 remember];
  return self;
}

-distrPayoffs {
  int action1, action2;

  action1 = [player1 getNewAction];
  action2 = [player2 getNewAction];
  [player1 setPayoff: [player1 getPayoff] + matrix[action1][action2]];
  [player2 setPayoff: [player2 getPayoff] + matrix[action2][action1]];
  return self;
}

-run {
  int t;

  for (t=0; t<numIter; t++) {
    [self updateMemories];
    [player1 step: t];
    [player2 step: t];
    [self distrPayoffs];
  }  
  return self;
}

@end



  


