// POL SCI 209-1  Winter 1999  Week 9

// Lars-Erik Cederman
// Benedikt Stefansson

// ExperIPD
// Swarm program that replicates the Cohen et al. spatial IPD
// (Configuration: B-2DK-Imit.)

// This version builds on ProbeIPD by adding an ExperSwarm that runs
// experimental replications if the user types a second argument on the command line


#import <simtools.h>               
#import "ObserverSwarm.h"
#import "ExperSwarm.h"

int
main(int argc,const char ** argv) {
  ObserverSwarm * observerSwarm;
  ExperSwarm * experSwarm;

  initSwarm(1,argv);

  if (argc == 1) {

    observerSwarm =  [ObserverSwarm create: globalZone];
    [observerSwarm buildObjects];
    [observerSwarm buildActions];
    [observerSwarm activateIn: nil];     
    [observerSwarm go];

  } else {

    experSwarm = [ExperSwarm create: globalZone];
    [experSwarm buildObjects];
    [experSwarm run];
    
  }

  return 0;

}


