// Schellings Segregation Model 
// Code by Benedikt Stefansson, <benedikt@ucla.edu>. 
// First version July 1997
// Second version February 1998

#import "Person.h"
#import "SchellingWorld.h"
#import "Neighborhood.h"
#import "Shuffler.h"
#import <objectbase.h>
#import <space.h>
#import <activity.h>
#import <collections.h>
#import <random.h>
#import <string.h>
#import <objectbase/Swarm.h>

@interface ModelSwarm : Swarm {
  int numAgents;
  char * neighborhood_type;
  int worldSize;
  double fractionVacant;
  double fractionBlue;
  double blueToleranceUpper;
  double blueToleranceLower;
  double redToleranceUpper;
  double redToleranceLower;
  unsigned randomSeed;
  
  id modelSchedule;

  id <PMMLCG1> aGenerator;
  id <UniformDouble> uniformDouble;
  id <UniformInteger> uniformInteger;
  
  id <List> agentList;
  id world;
  
}

+createBegin: (id) aZone;		
-createEnd;				
-buildObjects;
-buildActions;
-activateIn: (id) swarmContext;
-getAgentList;
-getWorld;
-(int)getWorldSize;
-(double)getRandomDoubleMin: (double) min Max: (double) max;
-(double)getRandomDouble;
-(int)getRandomIntMin: (int) min Max: (int) max;
@end
