// Schellings Segregation Model
// Code by Benedikt Stefansson, <benedikt@ucla.edu>. 
// First version July 1997
// Second version February 1998

#import "Neighborhood.h"
#import "Person.h"

@implementation Neighborhood

-setX: (int) x Y: (int) y {
	myX=x;
	myY=y;
	return self;
}

-setWorld: w {
	myWorld=w;
	return self;
}

-setType: (int) t {

  myType=t;
  
  return self;
}

-(int)getX {
	return myX;
}

-(int)getY {
	return myY;
}

-(float)getFractionOf: (int) t {
	float fraction=0.0;
	int xvals[4]={0,0,1,-1};
	int yvals[4]={-1,1,0,0};
	int i,j;
	Person * neighbor;

	if(myType==1) {
	  // This enforces a VonNeuman neighborhood
	  for(i=0;i<4;i++)
	    if((neighbor=[myWorld getObjectAtX: myX+xvals[i] Y: myY+yvals[i]]))
	      if([neighbor getColor]==t)
		fraction+=0.25;
	} else {
	  // This enforces a Moore neighborhood
	    for(i=-1;i<2;i++) 
	      for(j=-1;j<2;j++) 
		if((neighbor=[myWorld getObjectAtX: myX+i Y: myY+j]))
		  if([neighbor getColor]==t)
		    fraction+=0.125;
	}
    
	return fraction;
}

	
@end



