// Schelling's Segregation model
// Code by Benedikt Stefansson, <benedikt@ucla.edu>. 
// First version July 1997
// Second version February 1998


#import "Person.h"

@implementation Person

// A bunch of methods that set
// one parameter or another

-setWorld: w {
  myWorld=w;
  return self;
}

-setNeighborhood: n {
  myNeighborhood=n;
  return self;
}

-setAgentColor: (int) c {
  myColor=c;
  return self;
}

-setTolerance: (float) t {
  myTolerance=t;
  return self;
}

-step {

  // The method that implements the agents
  // actual behavior - look around and try
  // to move if you are unhappy
  unhappy=0;

  // Then see if you are happy in your neighborhood
  // and if you are not try to move somewhere else
  if((myTolerance<[myNeighborhood getFractionOf: (myColor==10)? 11 : 10]))
       	[self moveToNewLocation];
	
  return self;
}

-moveToNewLocation {
   
  // If we call this method we know we are
  // unhappy so we flick this switch here
  unhappy=1;

  // Find an empty neighbor according to
  // the definition of neighborhoood
  [myWorld findEmptyLocation: self];
 
  return self;
}

-drawSelfOn: (id) rast {
  // A method to draw the agent on the raster
  [rast drawPointX: [myNeighborhood getX] Y: [myNeighborhood getY] Color: myColor];
  return self;
}

// A bunch of methods to get parameters
-(int)getUnhappy {
	return unhappy;
}
		
-(int)getColor {
	return myColor;
}

-(double)getTolerance {
	return myTolerance;
}

-getNeighborhood {
	return myNeighborhood;
}

@end
