// Schellings Segregation Model
// Code by Benedikt Stefansson, <benedikt@ucla.edu>. 
// First version July 1997
// Second version February 1998

#import "SchellingWorld.h"


@implementation SchellingWorld

-setModelSwarm: m {
  modelSwarm=m;
  return self;
}

-move: o toX: (int) x Y: (int) y {
  id hood;

  hood=[o getNeighborhood];
  
  // To move an agent first we erase 
  // him in the original location 
  [self putObject: nil atX: [hood getX] Y: [hood getY]];

  // Then we move him to the new location
  [self putObject: o atX: x Y: y];

  // Finally we change the agent's neighborhood
  [hood setX: x Y: y];
  
  return self;
}

-findEmptyLocation: o {
  int x,y;
  int i,j;
  
  // Pick a random starting point
  x=(int)[modelSwarm getRandomIntMin: 0 Max: xsize];
  y=(int)[modelSwarm getRandomIntMin: 0 Max: ysize];
  
  // Find the first empty spot
  for(i=0;i<xsize;i++) 
    for(j=0;j<ysize;j++) 
      if(!([self getObjectAtX: x+i Y: y+j]))
	goto FoundIt;

  // This should never be called - but just in case
  // if no empty location is found stay in same place
  return [self move: o toX: [[o getNeighborhood] getX] Y: [[o getNeighborhood] getY]];
  
 FoundIt:
  return [self move: o toX: x+i Y: y+j];

}
	   

@end


