// ModelSwarm.m			

#import "ModelSwarm.h"

int matrix[2][2]={{1,5},{0,3}};

@implementation ModelSwarm

+createBegin: (id) aZone {
  ModelSwarm * obj;

  obj = [super createBegin: aZone];
  return obj;
}

-createEnd {
  return [super createEnd];

}

-buildObjects {
  
  player1 = [Player createBegin: self];
  [player1 initPlayer];
  player1 = [player1 createEnd];

  player2 = [Player createBegin: self];
  [player2 initPlayer]; 
  player2 = [player2 createEnd];

  [player1 setOtherPlayer: player2];
  [player2 setOtherPlayer: player1];

  return self;
}

-updateMemories {
  [player1 remember];
  [player2 remember];
  return self;
}

-distrPayoffs {
  int action1, action2;

  action1 = [player1 getNewAction];
  action2 = [player2 getNewAction];
  [player1 setPayoff: [player1 getPayoff] + matrix[action1][action2]];
  [player2 setPayoff: [player2 getPayoff] + matrix[action2][action1]];

  printf("Actions: [%d,%d] Payoffs: [%d,%d]\n",
	 action1, action2, [player1 getPayoff],[player2 getPayoff]);

  return self;
}

-buildActions {
  stopSchedule = [Schedule create: self];
  [stopSchedule at: 12 createActionTo: self message: M(stopRunning)];

  modelSchedule = [Schedule createBegin: self];
  [modelSchedule setRepeatInterval: 3];
  modelSchedule = [modelSchedule createEnd];

  playerActions = [ActionGroup createBegin: self];
  [playerActions createEnd];
  [playerActions createActionTo: player1  message: M(step)];
  [playerActions createActionTo: player2  message: M(step)];
  
  [modelSchedule at: 0 createActionTo: self message: M(updateMemories)];
  [modelSchedule at: 1 createAction: playerActions];
  [modelSchedule at: 2 createActionTo: self message: M(distrPayoffs)];

  return self;

}

-activateIn: (id) swarmContext {
  [super activateIn: swarmContext];
  [modelSchedule activateIn: self];
  [stopSchedule activateIn: self];

  return [self getActivity];

}

-stopRunning {
  printf("Payoffs: %d,%d\n",[player1 getPayoff],[player2 getPayoff]);
  [[self getActivity] terminate];
  return self;
}

@end



  


