// ModelSwarm.m			

#import "ModelSwarm.h"

@implementation ModelSwarm

+createBegin: (id) aZone {
  ModelSwarm * obj;
  obj = [super createBegin: aZone];
  return obj;
}

-createEnd {
  return [super createEnd];
}

-buildObjects: (int) n {
  int i;
  id anElement;

  objList = [List create:self];
  for (i=0; i<n; i++) {
    anElement = [Element create: self];
    [anElement init: i];
    [objList addLast: anElement];
  }
  return self;
}

-printObjects: list {
  id index, anElement;

  index = [list begin: self];
  while ((anElement=[index next]))
    printf("%d ", [anElement getID]);
  [index drop];

  printf("\n");
  return self;
}

-shuffle: list {
  int j, k;
  id temp;

  j = [list getCount];
  while (j>1) {
    k = [uniformIntRand getIntegerWithMin: 0 withMax: j-1];
    j--;
    temp = [list atOffset: k];
    [list atOffset: k put: [list atOffset: j]];
    [list atOffset: j put: temp];
  } 
  return self;
}

-run {
  int randomSeed;

  printf("Count: %d\n", [objList getCount]);
  printf("List:    ");
  [self printObjects: objList];

  for (randomSeed=1; randomSeed<=10; randomSeed++) {
    [randomGenerator setStateFromSeed: randomSeed];
    [self shuffle: objList];
    printf("Repl %2d: ", randomSeed);
    [self printObjects: objList];
  }
  return self;
}

@end



  


